# -*- coding: utf-8 -*-
# $Id: basecontainer.py 3737 2008-10-26 19:14:17Z hraban $
import grok
import os
from waeup.interfaces import IBaseContainer
import waeup.viewlets as vw
from zope.component import getMultiAdapter
from waeup.permissions import *

class BaseContainer(grok.Container):
    """
    The base container. This is a stub for now. It can have
    base methods attached to it
    """
    #grok.implements(IBaseContainer)
    #id = 'base'
    #name = u"BaseContainer"
    childClass = None
    specialActions = []
    
    def __init__(self, **kwargs):
        super(BaseContainer, self).__init__()
        self.__dict__.update(kwargs)
        self.ViewPermission = ViewBase
        self.AddPermission = AddBase
        self.EditPermission = EditBase

## Forms

class DisplayForm(grok.DisplayForm):
    grok.template('content')

    def __init__(self, context, request):
        super(DisplayForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context.__class__)

class AddForm(grok.AddForm):
    #template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))
    grok.template('edit_form')

    def __init__(self, context, request):
        super(AddForm, self).__init__(context, request)
        # ein Objekt der untergeordneten Klasse hinzufügen!
        self.form_fields = grok.AutoFields(self.context.childClass)

    @grok.action('Add item')
    def add(self, **data):
        obj = self.context.childClass(**data)
        id = data['id'].lower()
        #print "Add to container %s, ID %s, Obj %s" % (self.context, id, obj)
        self.context[id] = obj # schlägt fehlt bei falschem Interface! (not iterable)
        self.redirect(self.url('@@index'))

class EditForm(grok.EditForm):
    #template = grok.PageTemplate(filename=os.path.join('basecontainer_templates', 'edit_form.pt'))
    grok.template('edit_form')
    #form_fields = grok.AutoFields(BaseContainer)

    def __init__(self, context, request):
        super(EditForm, self).__init__(context, request)
        self.form_fields = grok.AutoFields(self.context.__class__)
        
#    def handle_edit_action(self, **data):
#        grok.EditForm.handle_edit_action(self, **data)
#        self.redirect(self.url('@@index'))

## Viewlets

class DisplayViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseContainer)
    grok.view(vw.Index)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request),
                                    name='displayform')
        self.form.update_form()

    def render(self):
        return self.form.render()
    
class AddViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    grok.context(IBaseContainer)
    grok.view(vw.Add)
    #grok.name('add')
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request), name='addform')
        self.form.update_form()

    def render(self):
        return self.form.render()

class EditViewlet(grok.Viewlet):
    grok.viewletmanager(vw.MainArea)
    #grok.context(IBaseContainer)
    grok.view(vw.Edit)
    #grok.name('edit')
    #grok.order(2)

    def update(self):
        self.form = getMultiAdapter((self.context, self.request), name='editform')
        self.form.update_form()

    def render(self):
        return self.form.render()
