## interfaces.py
# $Id: interfaces.py 3737 2008-10-26 19:14:17Z hraban $
import grok
import re
from zope import schema
from zope.interface import Interface

class IBaseContainer(grok.interfaces.IContainer):
    """
    ID is something that can be used in an URL and as an index, e.g.
    faculty/department codes
    """
    id = schema.ASCIILine(
        title = u'ID of Container',
        default = 'x',
        required = True,
        constraint = (re.compile('^\w+$').match)
        )
    name = schema.TextLine(
        title = u'Name of Container',
        default = u'Unnamed Container',
        required = True
        )
    

class IBaseItem(Interface): #(grok.interfaces.IContainer):
    """
    ID is something that can be used in an URL and as an index, e.g.
    course code, student ID
    """
    id = schema.ASCIILine(
        title = u'ID of Item',
        default = 'x',
        required = True,
        constraint = (re.compile('^\w+$').match)
        )
    name = schema.TextLine(
        title = u'Name of Item',
        default = u'Unnamed Item',
        required = True
        )

class IUniversity(grok.interfaces.IContainer):
    """Representation of a university.
    """
    id = schema.ASCIILine(
        title = u'ID of University',
        default = 'base',
        required = False,
        readonly = True
        )
    name = schema.TextLine(
        title = u'Name of University',
        default = u'Unnamed',
        required = True,
        )
