# -*- coding: utf-8 -*-
# $Id: faculty.py 3737 2008-10-26 19:14:17Z hraban $
import grok
import waeup.basecontainer as base
from waeup.interfaces import IBaseContainer
from waeup.university import permissions
from waeup.university.interfaces import IFaculty
from waeup.university.department import Department

class Faculty(base.BaseContainer):
    """
    This is a Faculty (part of University, contains Departments)
    """
    grok.implements(IFaculty)
    childClass = Department
    name = u'Faculty'
    plural_name = u'Faculties'
    ViewPermission = permissions.ViewFaculty
    AddPermission = permissions.AddFaculty
    EditPermission = permissions.EditFaculty

    def __init__(self, **kw):
        super(Faculty, self).__init__(**kw)
        self.__dict__.update(kw)
    
# Bei BaseContainer-Klassen müsen die beiden Viewlets ans Interface angepasst werden:
    
class DisplayViewlet(base.DisplayViewlet):
    grok.context(IFaculty)
    
class AddViewlet(base.AddViewlet):
    grok.context(IFaculty)
